with Text_Io; use Text_Io;
with Ada.Integer_Text_Io; use Ada.Integer_Text_Io;

with Semaphores; use Semaphores;

procedure Carrera is
	Contador_Compartido: Natural:=0;
	mutex: Semaphore (1);
	
	procedure Incrementar (Contador: in out Natural) is
		Local: Natural;
	begin	
			Local:= Contador;
			-- delay (0.01);
			Local:= Local+1;
			Contador:= Local;
			delay (0.01);
	end Incrementar;

	task Incrementador1;	-- Un proceso !!
	task Incrementador2;	-- Otro proceso

	task body Incrementador1 is	-- Esto hace el primer proceso
	begin
		for Indice in 1..20 loop
			mutex.down;
			Incrementar (Contador_Compartido);
			--delay (0.01);
			Put (1,1 *20); Put (":"); Put(Contador_Compartido); 
			New_Line;
			mutex.up;
			delay (0.01);
			--New_Line;
		end loop;
	end Incrementador1;

	task body Incrementador2 is	-- Esto hace el segundo proceso
	begin
		for Indice in 1..20 loop
			mutex.down;	
			Incrementar (Contador_Compartido);
			--delay (0.01);
			Put (2,2 *20); Put(":"); Put(Contador_Compartido);
			New_Line;
			mutex.up;
			delay (0.01);
			--New_Line;	
		end loop;
	end Incrementador2;

begin
	null;
end Carrera;
