-- Creacion de un proceso hijo (que ejecuta "ls") 
-- y el padre espera a que termine.
-- System Calls: write, fork, wait, execl, exit

with Unix;
procedure Ex6 is
   Msg: constant String := "He comenzado a ejecutar el padre" 
                           & Ascii.Lf;
   Men_Padre: constant String := "Soy el padre y acabo" 
                                 & Ascii.Lf;
   Men_Hijo : constant String := "Soy el hijo" 
                                 & Ascii.Lf;
   Pid    : Natural;
   Pid_Aux: Natural;
   Status : aliased Natural;
begin
   Unix.Write(1, Msg, Msg'Length );
   Pid := Unix.Fork;
   if Pid = 0 then
      Unix.Write(1, Men_Hijo, Men_Hijo'Length );
      Unix.Execlp("/bin/ls","ls","-l");
   else
      Pid_Aux := Unix.Wait(Status'Unchecked_Access);
      Unix.Write(1, Men_Padre, Men_Padre'Length );
      Unix.Sys_Exit(0);
   end if;
end Ex6;

