with Text_IO; use Text_IO;
with Ada.Integer_Text_Io; use Ada.Integer_Text_Io;
with Semaphores; use Semaphores;
procedure Belleza is

--  ------------------------------------------------------------------ 
   NumeroActual : Integer := 0;
   NumeroMasajista: Integer :=0;
   MutexTotal: Semaphore(27);
   MutexNumActual: Semaphore(1);
   MutexNumActualMasajista: Semaphore(1);
   MutexSalaDePie: Semaphore(20);
   MutexSalaSentado: Semaphore (4);
   MutexMasaje: Semaphore (0);
   MutexCobrar: Semaphore (1);
   MutexAux: Semaphore (0);
   MutexAux2:Semaphore (3);

-- -------------------------------------------------------------------
   function ObtenerNumero return Integer is
      NuevoValor : Integer;
   begin
      MutexNumActual.Down;
      NumeroActual := NumeroActual+1;
      NuevoValor   := NumeroActual;
      MutexNumActual.Up;
      return NuevoValor;
   end;
   
   function ObtenerNumeroMasajista return Integer is
	NuevoValor2 : Integer;
   begin
	MutexNumActualMasajista.Down;
	NumeroMasajista:=NumeroMasajista+1;
	NuevoValor2:=NumeroMasajista;
	MutexNumActualMasajista.Up;
	return NuevoValor2;
   end;
--  ------------------------------------------------------------------ 

   task type TCliente;
   task type TMasajistas;

   task body TCliente is
      NumeroCliente : Integer;
   begin
	NumeroCliente := ObtenerNumero;
	Put("Hola, soy el cliente "); Put(NumeroCliente); New_Line;
	MutexTotal.down;
	   MutexSalaDePie.down;
		Put ("Ahora, estoy de pie, y soy: ");Put (NumeroCliente);
		New_Line;
		MutexSalaSentado.down;
		    Put ("Ahora, estoy sentado, y soy: ");Put(NumeroCliente);
   		    New_Line;
	   MutexSalaDePie.up;    
			MutexMasaje.down;
			Put ("Ahora, maaasaaajeeer, y soy: ");
			Put(NumeroCliente); New_Line;
		MutexSalaSentado.up;
			--delay (0.01);
				
			MutexCobrar.down;
				--MutexAux.up;
				delay (0.01);
				Put ("Ahora, estoy pagando y soy: ");
				Put (NumeroCliente); New_Line;
				MutexAux.up;
			MutexCobrar.up;
		    --MutexMasaje.up;
		--MutexSalaSentado.up;
	   -- MutexSalaDePie.up;
       MutexTotal.up;
   end;

   task body TMasajistas is
	NumeroMasajista: Integer;
   begin
	NumeroMasajista:= ObtenerNumeroMasajista;
	loop
	MutexMasaje.up;
	Put ("MASAJISTA: ESTOY DANDO UN MASAJE Y SOY: "); 
	Put (NumeroMasajista); New_Line;
	Mutexaux.down;
	Put ("MASAJISTA: ESTOY COBRANDO Y SOY: "); Put (NumeroMasajista);
	New_Line;
	end loop;
   end;

   

--  ------------------------------------------------------------------    
	Clientes: array(1..50) of TCliente;
	Masajistas: array (1..3) of TMasajistas;
begin
   null;
end;

