-- Copia de fichero mediante redireccionamiento de 
-- la entrada y la salida.
-- System Calls: open, creat, close, read, write.
-- Equivalente en Bourne Shell: cat < f1.in > f2.out

with Unix;
procedure Ex2 is

   Buffer    : String(1..5):=(others => ' ');
   Bytes_Read: Natural;
   F1     : Integer;
   F2     : Integer;
   New_Fd1: Integer;
   New_Fd2: Integer;
begin
   F1 := Unix.Open("f1.in", Unix.O_RDONLY);
   F2 := Unix.Creat("f2.out",8#600#);
   Unix.Close(0);
   Unix.Close(1);
   New_Fd1 := Unix.Dup(F1);
   New_Fd2 := Unix.Dup(F2);
   loop
      Unix.Read(0,Buffer,Buffer'Length,Bytes_Read);
      exit when Bytes_Read = 0;
      Unix.Write(1,Buffer,Bytes_Read);
   end loop;
   Unix.Close(F1);
   Unix.Close(F2);
end Ex2;
