-- Comunicacion entre el padre y el hijo mediante 
-- "pipe".
-- System Calls: pipe, write, fork, wait, sys_exit

with Unix;
procedure Ex7 is
   Mi_Pipe    : Unix.T_Fildes;
   Pid        : Integer;
   Msg        : constant String 
                 := "Mensaje que paso a mi padre" & Ascii.Lf;
   Pid_Aux    : Integer;
   Status     : aliased Natural;
   Mensaje    : String(1..512);
   NBytes_Read: Natural;   
begin
   Unix.Pipe(Mi_Pipe);
   Pid := Unix.Fork;
   if Pid = 0 then
      Unix.Write(Mi_Pipe(1), Msg, Msg'Length );
      Unix.Sys_Exit(0);
   else
      Pid_Aux    := Unix.Wait(Status'Unchecked_Access);
      Unix.Read(Mi_Pipe(0), Mensaje, 
           Mensaje'Length, Nbytes_Read);
      Unix.Write(1, Mensaje, NBytes_Read);
      Unix.Sys_Exit(0);
   end if;
end Ex7;

