-- Ejecucion de "ls -l | cat > file.out".
-- System Calls: pipe, write, fork, wait, sys_exit

with Unix;
procedure Ex8 is
   Mi_Pipe: Unix.T_Fildes;
   Pid    : Integer;
   Fd     : Integer;
   New_Fd : Integer;
begin
   Unix.Pipe(Mi_Pipe);
   Pid := Unix.Fork;
   if Pid = 0 then
      Unix.Close(Mi_Pipe(0)); 

      Unix.Close(1); 
      New_Fd := Unix.Dup( Mi_Pipe(1) ); 
      Unix.Close( Mi_Pipe(1) );

      Unix.Execlp("/bin/ls","ls","-l");
   else
      Unix.Close(Mi_Pipe(1));

      Fd := Unix.Creat("file.out",8#0600#);
      Unix.Close(1); 
      New_Fd := Unix.Dup(Fd); 
      Unix.Close(Fd);
      
      Unix.Close(0); 
      New_Fd := Unix.Dup(Mi_Pipe(0) ); 
      Unix.Close(Mi_Pipe(0));
      
      Unix.Execlp("/bin/cat","cat");
      Unix.Close(1);
      Unix.Sys_Exit(0);
   end if;
end Ex8;

